{% load qr_code %}

<style>
    body{
        margin:0;
        padding:0;
        overflow:hidden;
        font-family:sans-serif;
        background-color: #f3f2e9;
        /*cursor: none;*/
    }
    #welcome{
        display:none;
        flex-direction: column;
        justify-content: space-around;
        align-items: center;
        width:100%;
        height: 100%;
    }
    #loading{
        display: flex;
        justify-content: center;
        align-items: center;
        width:100%;
        height:100%;
        color:black;
        flex-direction:column;
    }
    #qr{
        width:100%;
        display:flex;
        flex-direction:column;
        align-items:center;
    }
    #logo{
        height: 30%;
        min-height: 10%;
        margin-top: 30px;
    }
    #logo img {
        height: 100%;
    }
    #text {
        text-align:center;
        padding:0% 10%;
        margin-bottom: 1rem;
    }
    p {
        margin: 0px; 
    }
    @media screen and (min-height: 801px) {
      p {
        font-size:3em;
      }
      .tracker_on{
          display:block;
          clear:both;
        margin-top:70px;
        font-size:2em;
      }
    }
    @media screen and (max-height: 800px) {
      p {
        font-size:2em;
      }
      .tracker_on{
        display:block;
        margin-top:70px;
        font-size:1em;
      }
    }
    
    #close-container {
        position: absolute;
        right: 0px;
        top: 0px;
        min-width: 300px;
        min-height: 300px;
        padding: 30px;
        display: flex;
        justify-content: flex-end;
        z-index: 1000;
    }
    #close-container:hover #close-icon.ready {
        opacity: 1;
    }
    #close-icon {
        width: 50px;
        height: 50px;
        opacity: 0;
        transition: opacity 0.2s;
    }

</style>
<div id="close-container">
    <div id="close-icon">
        <svg width="100%" height="100%" viewBox="0 0 17 17" fill="none" xmlns="http://www.w3.org/2000/svg">
            <path fill-rule="evenodd" clip-rule="evenodd" d="M16 1.82792L2.82792 14.9999L2 14.172L15.1721 1L16 1.82792Z" fill="#3580c2"/>
            <path fill-rule="evenodd" clip-rule="evenodd" d="M15.1721 15L2.00009 1.82793L2.828 1L16 14.172L15.1721 15Z" fill="#3580c2"/>
        </svg>
    </div>
</div>
<div id="loading">
    <p>Caricamento in corso...</p>
    <p class="tracker_on">Assicurati che il puntatore oculare sia connesso al computer</p>

</div>
<div id="welcome">
    <!-- <h1>Benvenuto!</h1> -->
    {% load static %}
    <div id="logo">
        <img src="{% static "imgs/logo.png"%}">
    </div>
    <div id="qr">
        {% qr_from_text ip options=qr_options %}
    </div>
    <div id="text">
        <p>Assicurati che il tablet sia connesso alla rete <b>{{ ssid }}</b>, Inquadra il codice QR con il tablet ed attendi la vibrazione</p>
    </div>
</div>

<script>


    function changeLocation(data){
        let getUrl = window.location;
        let baseUrl = getUrl .protocol + "//" + getUrl.host
        let gameurl = baseUrl + data.gameurl
        gameurl += "?session="  + data.session
        gameurl += "&skipintro="  + data.skipIntro
        gameurl += "&level="  + data.level
        gameurl += "&round="  + data.round
        data.dynamics.forEach(function(d){
            gameurl += "&" + d.id + "=" + d.value
        })

        window.location.replace(gameurl);
    }

    function goToCalibration(){
        let getUrl = window.location;
        let baseUrl = getUrl .protocol + "//" + getUrl.host
        let calibrateUrl = baseUrl+"/app/calibration/"
        window.location.replace(calibrateUrl);
    }

    function connect(){
        let trackerconnection = new WebSocket("ws://localhost:5001");
        trackerconnection.onopen = () => {
            trackerconnection.send(JSON.stringify({type:"room",data:"desktop"}));
            console.log("hello tracker!")
            showWelcome()
        }

            //on close
        trackerconnection.onclose = function (err) {
            console.log("bye tracker!", err)
            setTimeout(()=>{connect()}, 1000)
        };


         //on message
        trackerconnection.onmessage = (message) => {
            const msg = JSON.parse(message.data);
            switch(msg.type){
                case "run_calibration":
                    console.log(msg);
                    goToCalibration();
                    break;

                case "new_session":
                    console.log("new session", msg.data);
                    changeLocation(msg.data);

                    //this.gaze = msg.data;
                    break;
                case "new_mobile_client":
                    let getUrl = window.location;
                    let baseUrl = getUrl .protocol + "//" + getUrl.host
                    window.location = baseUrl + "/app/homepage/"
                    break;
                default:
                    break
            }
        };

        //on error
        trackerconnection.onerror = function (err) {console.log("error tracker!", err)};
    }

    function showWelcome(){
        var elem = document.getElementById("loading");
        var elem2 = document.getElementById("welcome");
        elem.style.display = 'none';
        elem2.style.display = 'flex';
    }

    let eventconnection = undefined;
    let connetionopen = false;
    const close = document.getElementById("close-icon");

    let eventwsConnect = function() {
        //instanciate
        eventconnection = new WebSocket("ws://localhost:5002");
        //on open
        eventconnection.onopen = () => {
            connetionopen = true;
            close.classList.add("ready");
        }
        //on close
        eventconnection.onclose = (err) => {
            connetionopen = false;
            close.classList.remove("ready");
            setTimeout(()=>{eventwsConnect()},3000)
        };
        //on message
        eventconnection.onmessage = (message) => {};
        //on error
        eventconnection.onerror = function (err) {};
    }

    close.addEventListener("click", () => {
        if (connetionopen) eventconnection.send(JSON.stringify({type:"terminate"}));
    })

    eventwsConnect();
    connect();
</script>